/**
 * easyWSDL - easyWSDL toolbox Platform.
 * Copyright (c) 2008,  eBM Websourcing
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the University of California, Berkeley nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package org.ow2.easywsdl.wsdl.decorator;

import java.util.List;
import java.util.Map;

import javax.xml.namespace.QName;

import org.ow2.easywsdl.schema.api.Documentation;
import org.ow2.easywsdl.schema.api.XmlException;
import org.ow2.easywsdl.schema.api.abstractElmt.AbstractSchemaElementImpl;
import org.ow2.easywsdl.wsdl.api.WSDLElement;
import org.ow2.easywsdl.wsdl.api.WSDLException;
import org.ow2.easywsdl.wsdl.api.abstractElmt.AbstractWSDLElementImpl;
import org.ow2.easywsdl.wsdl.api.abstractItf.AbsItfInterfaceType;
import org.ow2.easywsdl.wsdl.api.abstractItf.AbsItfOperation;
import org.w3c.dom.Element;


/**
 * @author Nicolas Salatge - eBM WebSourcing
 */
@SuppressWarnings("unchecked")
public class DecoratorInterfaceTypeImpl<O extends AbsItfOperation>  extends AbstractWSDLElementImpl implements Decorator {

    /**
	 *
	 */
    private static final long serialVersionUID = 1L;

    protected AbsItfInterfaceType<O> itf;

    public DecoratorInterfaceTypeImpl(final AbsItfInterfaceType<O> itf) throws WSDLException {
        this.itf = itf;
    }

    public void addOperation(final O arg0) {
        this.itf.addOperation(arg0);
    }

    public O getOperation(final QName arg0) {
        return this.itf.getOperation(arg0);
    }

    public List<O> getOperations() {
        return this.itf.getOperations();
    }

    public QName getQName() {
        return this.itf.getQName();
    }

    public O removeOperation(final String arg0) {
        return this.itf.removeOperation(arg0);
    }

    public void setQName(final QName arg0) {
        this.itf.setQName(arg0);
    }

    public Documentation createDocumentation() {
        return this.itf.createDocumentation();
    }

    public Documentation getDocumentation() {
        return this.itf.getDocumentation();
    }

    public Map<QName, String> getOtherAttributes() throws XmlException {
        return this.itf.getOtherAttributes();
    }

    public List<Element> getOtherElements() throws XmlException {
        return this.itf.getOtherElements();
    }

    public void setDocumentation(final Documentation arg0) {
        this.itf.setDocumentation(arg0);
    }

	public O createOperation() {
		return this.itf.createOperation();
	}

    @Override
	public Object getModel() {
		return ((AbstractWSDLElementImpl)this.itf).getModel();
	}

    @Override
	public AbstractSchemaElementImpl getParent() {
		return ((AbstractWSDLElementImpl)this.itf).getParent();
	}

	public WSDLElement getDecorator() {
		return this.itf;
	}
}
